=== debian/changelog ===
openmodelica (11645-1) unstable; urgency=low

  * Automatic subversion build
 -- OpenModelica Build System <build@openmodelica.org>  Tue, 03 Apr 2012 14:33:11 +0200
